<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width">
  <title>Dependency Management Data</title>
  <link rel="stylesheet" href="https://classless.de/classless.css">
  <meta name="go-import" content="dmd.tanna.dev git https://gitlab.com/tanna.dev/dependency-management-data">
  <meta name="go-source"
    content="dmd.tanna.dev _ https://gitlab.com/tanna.dev/dependency-management-data/tree/main{/dir} https://gitlab.com/tanna.dev/dependency-management-data/blob/main{/dir}/{file}#L{line}">

  <style type="text/css" media="all">
    :root {
      --font-p: 1em/1.7 monospace;
      --font-h: .9em/1.5 monospace;
      --font-c: .9em/1.4 monospace;
      --width: 70rem;

      --cfg: #ebdbb2;
      --cdark: #3c3836;
      --cmed: #7c6f64;
      --clight: #fbf1c7;
      --clink: #83a598;
      --cemph: #fe8019;
      --cbg: #282828;

      --c-primary: #b16286;
    }

    code {
      color: var(--cbg);
    }

    time {
      color: var(--cmed);
    }

    tr:hover {
      color: var(--cdark);
    }

    ::selection {
      color: var(--cfg);
      background-color: var(--c-primary);
    }

    h1.name {
      font-size: 3em;
    }

    h1.name span {
      color: var(--c-primary);
    }
  </style>
</head>

<body>

  <h1>Dependency Management Data (DMD)</h1>

  <p>Dependency Management Data is a set of tooling to get a better understanding of the use of dependencies across your
    organisation.</p>

  <p>The aim is to provide you with a set of queryable data about how your projects use configured, so you can target
    changes across your projects and organisation more appropriately.</p>

  <p>There is <a href="https://gitlab.com/tanna.dev/dependency-management-data#command-line-tool">a command-line
      tool</a>, <code>dmd</code>, which aims to make this an easier way to interact with the data.</p>

  <p>There is an <a href="https://gitlab.com/tanna.dev/dependency-management-data-example">example repo</a> that provides some a pre-seeded database, and set of data exports, that you can test the experience with.</p>

  <p>Some examples of setting up the data model:</p>

  <ul>
    <li><a href="https://www.jvt.me/posts/2022/11/01/renovate-dependency-graph/">Extracting the dependency tree from
        Renovate for given repositories</a></li>
    <li><a href="https://www.jvt.me/posts/2022/09/29/roo-hacktoberfest-dependency-analysis/">Analysing our dependency
        trees to determine where we should send Open Source contributions for Hacktoberfest</a></li>
  </ul>

  <p>Some examples of queries:</p>

  <ul>
    <li>Show the use of unstable versions - <code>select * from packages where currentValue like '0.%' or currentValue
        like 'v0.%';</code></li>
    <li>Show the list of packages by package manager - <code>select packageManager, count(*) from packages group by
        packageManager order by count(*) DESC;</code></li>
  </ul>

  <p><strong>NOTE</strong> this is currently a work-in-progress and will likely contain more information and tooling
    later on, possibly even included a hosted service!</p>

  <p>Also see <a href="https://gitlab.com/tanna.dev/dependency-management-data">the repository on GitLab.com</a>.</p>

  <script type="text/javascript" charset="utf-8">
    var _paq = _paq || [];
    _paq.push(['trackPageView']);
    _paq.push(['enableLinkTracking']);
    (function() {
          var u="https://stats.jvt.me/";
          _paq.push(['setTrackerUrl', u+'matomo.php']);
          _paq.push(['setSiteId', 17]);
          var d=document, g=d.createElement('script'), s=d.getElementsByTagName('script')[0];
          g.type='text/javascript'; g.async=true; g.defer=true; g.src=u+'matomo.js'; s.parentNode.insertBefore(g,s);
        })();
  </script>
  <noscript><p><img src="https://stats.jvt.me/matomo.php?idsite=16" style="border:0;" alt="Matomo tracking image" /></p></noscript>

</body>

</html>
